#include "COMM/stc.h"        //ͷļ
#include "COMM/usb.h"
#include "seg_led.h"
#include "key.h"
#include "beep.h"
#include "tim0.h"

#define MAIN_Fosc 24000000UL    //ʱ

char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";

bit TIM_10MS_Flag;            //10msı־λ 

// 
void Update_Temperature_Display(u16 temperature);
void Clear_Temperature_Display(void);


void sys_init();    //
void delay_ms(u16 ms);    //ʱ

// ¯ر
u8 heating_mode = 0;        //ǰģʽ0=δѡ1=£2=£3=
u16 current_temperature = 0; //ǰʾ¶
u16 target_temperature = 0;  //Ŀ¶

// ģʽ¶趨
const u16 LOW_TEMP = 100;
const u16 MID_TEMP = 200;
const u16 HIGH_TEMP = 300;

void main()                    
{
    u8 KEY_NUM = 0;            //水ļ
    u16 simulated_temperature = 0;  //ģµı
    
    sys_init();                //USB+IOڳʼ
    usb_init();                //usbʼ

    Timer0_Init();
    EA = 1;                    //CPUжϣжϡ
    
    LED = 0xff;                //ʼ״̬ϨLED
    
    while(1)                   //ѭ
    {
        if( DeviceState != DEVSTATE_CONFIGURED )    
            continue;
        
        if( bUsbOutReady )                                
        {
            usb_OUT_done();
        }
        
        if( TIM_10MS_Flag == 1 )                        //10ms
        {
            TIM_10MS_Flag = 0;                          //ձ־λ
            BEEP_RUN();                                 //
            
            // ȡֵ
            KEY_NUM = MateixKEY_Read();
            
            if( KEY_NUM > 0 )                           //а
            {
                BEEP_ON(2);                             //ʾ
                
                if(KEY_NUM == 1)                        //
                {
                    if(heating_mode == 0)               //ǰδ
                    {
                        heating_mode = (heating_mode % 3) + 1;  //лģʽ
                        
                        if(heating_mode == 1)
                            target_temperature = LOW_TEMP;
                        else if(heating_mode == 2)
                            target_temperature = MID_TEMP;
                        else if(heating_mode == 3)
                            target_temperature = HIGH_TEMP;
                        
                        LED = ~(1 << (heating_mode - 1));  //ӦģʽLED
                        
                        // ʾʾǰģʽ¶
                        Update_Temperature_Display(target_temperature);
                    }
                    else                                // Ѿڼȣػ
                    {
                        heating_mode = 0;               //ֹͣ
                        LED = 0xff;                     //ϨLED
                        BEEP_ON(50);                    //ػʾ
                        
                        // ʾ
                        Clear_Temperature_Display();
                    }
                }
                else if(KEY_NUM == 2 && heating_mode > 0)  //ȷϼʼ
                {
                    BEEP_ON(20);                       //ʾȷ
                    delay_ms(1000);                    //ȴ1
                    simulated_temperature = 0;         //ģ´0ʼ
                    while(simulated_temperature < target_temperature)
                    {
                        delay_ms(1000);                //ÿ1
                        simulated_temperature++;
                        Update_Temperature_Display(simulated_temperature); //ʾ¶
                    }
                    BEEP_ON(200);                      //ʾ2
                    delay_ms(2000);                    //2
                    heating_mode = 0;                  //Ƚػ
                    LED = 0xff;                        //ϨLED
                    Clear_Temperature_Display();       //ʾ
                }
                else if(KEY_NUM == 3 && heating_mode > 0)  //Ӻż¶
                {
                    if(target_temperature < HIGH_TEMP)   //Ϊģʽ
                    {
                        target_temperature += 10;
                    }
                    Update_Temperature_Display(target_temperature); //ˢʾǰ¶
                }
                else if(KEY_NUM == 4 && heating_mode > 0)  //ż¶
                {
                    if(target_temperature > LOW_TEMP)    //Ϊģʽ
                    {
                        target_temperature -= 10;
                    }
                    Update_Temperature_Display(target_temperature); //ˢʾǰ¶
                }
                else if(KEY_NUM == 5)                     //ģʽѡ
                {
                    static u8 mode_select = 0;
                    mode_select = (mode_select % 3) + 1;  // лģʽ1=70C, 2=90C, 3=100C
                    if(mode_select == 1)
                        target_temperature = 70;
                    else if(mode_select == 2)
                        target_temperature = 90;
                    else if(mode_select == 3)
                        target_temperature = 100;
                    
                    Update_Temperature_Display(target_temperature); //ʾѡĿ¶
                }
            }
        }
    }
}





// ʱ0жϺ
void Timer0_Isr(void) interrupt 1
{
    static timcount = 0;
    
    SEG_LED_Show();            //ˢʾǰ¶
    
    timcount++;                //1ms+1
    if( timcount >= 10 )       //10ms
    {
        timcount = 0;
        TIM_10MS_Flag = 1;    //10ms־λ
    }
}

// ϵͳʼ
void sys_init()        //
{
    WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; //չĴ(XFR)ʹ
    CKCON = 0; //߷XRAMٶ

    P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ׼˫
    P1M1 = 0x00;   P1M0 = 0x00;   //Ϊ׼˫
    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
    P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
    P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
    P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫
    
    P3M0 = 0x00;
    P3M1 = 0x00;
    
    P3M0 &= ~0x03;
    P3M1 |= 0x03;

    //USBʹõʱԴ
    IRC48MCR = 0x80;    //ʹڲ48MIRC
    while (!(IRC48MCR & 0x01));  //ȴʱȶ

    USBCLK = 0x00;    //ʹCDCҪʹУHIDܽС
    USBCON = 0x90;
}

// ʱ
void delay_ms(u16 ms)    //unsigned int 
{
    u16 i;
    do
    {
        i = MAIN_Fosc/6000;
        while(--i);
    }while(--ms);
}
